<template lang="pug">
    project(
      v-if="startProject"
      v-bind:collage="collage"
    )
</template>

<script>
import photosApi from '../../../api/photos'
import dataService from '../../../services/data'

export default {
  name: 'PhotoPage',
  layout: 'editor',
  data () {
    return {
      startProject: false,
      collage: null,
      errorStatusCode: null
    }
  },
  asyncData ({ store, params }) {
    return new Promise(function (resolve, reject) {
      photosApi.getUserCollage(params.id)
        .then(collage => {
          store.dispatch('updateSEO', dataService.getSeo(collage))
          resolve({
            collage: dataService.handleCollage(collage)
          })
        })
        .catch(error => {
          store.dispatch('updateSEO', dataService.getSeo())
          resolve({ errorStatusCode: error.response ? error.response.status : 500 })
        })
    })
  },
  mounted () {
    this.startProject = true
    if (this.errorStatusCode) {
      this.$root.error({ statusCode: this.errorStatusCode })
    }
  }
}
</script>
